/**
 * 
 */
package org.gcube.portlets.user.td.csvexportwidget.client.progress;




import com.allen_sauer.gwt.log.client.Log;
import com.sencha.gxt.widget.core.client.ProgressBar;

/**
 * Updates a {@link ProgressBar} progress and text based on {@link CSVExportProgressListener} events.
 * 
 * @author "Giancarlo Panichi" 
 * <a href="mailto:g.panichi@isti.cnr.it">g.panichi@isti.cnr.it</a> 
 *
 */
public class CSVExportProgressBarUpdater implements CSVExportProgressListener {
	
	protected ProgressBar progressBar;
	//protected FramedPanel operationResult;
	//protected WizardWindow wizardWindow;
	/**
	 * Creates a new {@link ProgressBar} updater.
	 * @param progressBar the {@link ProgressBar} to update.
	 */
	public CSVExportProgressBarUpdater(ProgressBar progressBar) {
		this.progressBar = progressBar;
	}

	
	/**
	 * {@inheritDoc}
	 */
	public void operationComplete() {
		Log.info("Export completed");
		progressBar.updateProgress(1, "Export completed.");	
		
	}

	/**
	 * {@inheritDoc}
	 */
	public void operationFailed(Throwable caught, String reason, String failureDetails) {
		Log.info("Export failed");
		progressBar.updateText("Export failed.");
	}

	public void operationInitializing() {
		Log.info("Export Inizializing");
		progressBar.updateProgress(0, "Initializing...");
	}

	
	public void operationUpdate(float elaborated) {
		Log.info("Export elaborated: "+elaborated);
		if (elaborated == 0) progressBar.updateProgress(0, "Initializing...");
		if (elaborated>0 && elaborated<1) {
			Log.trace("progress "+elaborated);
			int elab=new Float(elaborated*100).intValue();
			progressBar.updateProgress(elaborated,elab+"% Exporting...");
		}
		if (elaborated == 1) progressBar.updateProgress(1, "Completing...");
		
	}

}
